// AqEmuDlg.h : header file
//

#if !defined(AFX_AQEMUDLG_H__3BF086E6_221A_11D4_AA61_F0932AF13309__INCLUDED_)
#define AFX_AQEMUDLG_H__3BF086E6_221A_11D4_AA61_F0932AF13309__INCLUDED_

#include "Z80.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CAqEmuDlg dialog

class CAqEmuDlg : public CDialog
{
// Construction
public:
	signed int nResult;
	int nSpaces;
	BOOL bCtrlDown;
	CString strMsg;
	BOOL bShiftDown;
	void FillKeyTable();
	UINT KeyBoard[256];
	void ZapIoSpace();
	BOOL AqCtrlKey;
	BOOL AqShiftKey;
	BOOL nAddrStop;
	UINT nAddrStart;
	CString strRomFileName;
	CString strTrace;
	BOOL bLogging;
	CFile cfLogFile;
	void SetParity();
	BYTE Parity[256];
	BOOL bParityEven;
	BYTE nOldA;
	signed char dd; //Displacment byte +/- 0-127
	UINT nAddr;
	long lCount;
	BOOL bLooping;
	BOOL bRomLoaded;
	BOOL RunProc(UINT nStartAddr,UINT nStopAddr);
	CFile m_RomFile;
	int ExecuteInstruction();
	BYTE IoSpace[64*1024];		//64K I/O Space
	void ShowChar(UINT x, UINT y, UINT nChar);
	void InvalidateScreen();
	BYTE Memory[64*1024];		//64K Z80 Memory space
	UINT nTimerID;
	int	 nZoomX;
	int  nZoomY;
	void DoEvents();
	BOOL bRun;
	CAqEmuDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAqEmuDlg)
	enum { IDD = IDD_AQEMU_DIALOG };
	CEdit	m_StatBar;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAqEmuDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	Z80 myZ80;

	CBitmap m_Bitmap1;
	UINT nPort;
	UINT nVal;
	BOOL bInitDone;
	CBitmap* pOldBitmap ;
	CDC dcb;			// device contect for the bitmaps
	CDC* myCDC;
	void ZapMemory();
	void DrawScreen();
	HICON m_hIcon;
 
	// Generated message map functions
	//{{AFX_MSG(CAqEmuDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAboutbox();
	afx_msg void OnProcPause();
	afx_msg void OnView100();
	afx_msg void OnView200();
	afx_msg void OnView400();
	afx_msg void OnTimer(UINT nIDEvent);
	virtual void OnOK();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSysKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnProcessorReset();
	afx_msg void OnLoadRom();
	afx_msg void OnViewClearScreenRam();
	afx_msg void OnProcessorAdvanced();
	afx_msg void OnProcessorStart();
	afx_msg void OnDebugLogToFile();
	afx_msg void OnDebugStoplogging();
	virtual void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnFileExit();
	afx_msg void OnDebugTest();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AQEMUDLG_H__3BF086E6_221A_11D4_AA61_F0932AF13309__INCLUDED_)
